
QuietCast = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceHook-2.1")

local _G = _G
local QuietCast = QuietCast

local	errorList
local eventList

function QuietCast:OnInitialize()

	-- Ripped from ErrorMonster, thanks Rabbit
	errorList = {
			SPELL_FAILED_NO_COMBO_POINTS,   -- That ability requires combo points
			SPELL_FAILED_TARGETS_DEAD,      -- Your target is dead
			SPELL_FAILED_SPELL_IN_PROGRESS, -- Another action is in progress
			SPELL_FAILED_TARGET_AURASTATE,  -- You can't do that yet. (TargetAura)
			SPELL_FAILED_CASTER_AURASTATE,  -- You can't do that yet. (CasterAura)
			SPELL_FAILED_NO_ENDURANCE,      -- Not enough endurance
			SPELL_FAILED_BAD_TARGETS,       -- Invalid target
			SPELL_FAILED_NOT_MOUNTED,       -- You are mounted
			SPELL_FAILED_NOT_ON_TAXI,       -- You are in flight
			SPELL_FAILED_NOT_INFRONT,       -- You must be in front of your target
			SPELL_FAILED_NOT_IN_CONTROL,    -- You are not in control of your actions
			SPELL_FAILED_MOVING,            -- Can't do that while moving
			SPELL_FAILED_INTERRUPTED, 
			SPELL_FAILED_INTERRUPTED_COMBAT,
			SPELL_FAILED_UNIT_NOT_INFRONT,
			SPELL_FAILED_SPELL_UNAVAILABLE,
			SPELL_FAILED_STUNNED,
			ERR_USE_BAD_ANGLE,
			ERR_GENERIC_NO_TARGET,          -- You have no target.
			ERR_ABILITY_COOLDOWN,           -- Ability is not ready yet.
			ERR_OUT_OF_ENERGY,              -- Not enough energy
			ERR_NO_ATTACK_TARGET,           -- There is nothing to attack.
			ERR_SPELL_COOLDOWN,             -- Spell is not ready yet. (Spell)
			ERR_OUT_OF_RAGE,                -- Not enough rage.
			ERR_INVALID_ATTACK_TARGET,      -- You cannot attack that target.
			ERR_OUT_OF_MANA,                -- Not enough mana
			ERR_NOEMOTEWHILERUNNING,        -- You can't do that while moving!
			OUT_OF_ENERGY,                  -- Not enough energy.
	}

	self:RegisterChatCommand(
		{"/quietcast", "/quiet", "/qc"}, 
		{
			type = 'execute',
			name = 'QuietCast',
			desc = 'Sink next casting error',
			func = 'DoHook'
		}
	)
	
	eventList = {
		"UNIT_SPELLCAST_SUCCEEDED",
		--"UNIT_SPELLCAST_CHANNEL_STOP",
		--"UNIT_SPELLCAST_STOP",
		--"UNIT_SPELLCAST_FAILED",
		--"UNIT_SPELLCAST_INTERRUPTED",
	}

end

function QuietCast:SpellEvent(unit)
	if unit == "player" then 
		return self:DoUnhook()
	end
end

local saveErrorSpeech

function QuietCast:DoHook()
	if self:IsHooked("UIErrorsFrame_OnEvent") then
		return
	end
	self:Hook("UIErrorsFrame_OnEvent", true)
	for i, event in pairs(eventList) do
		self:RegisterEvent(event, "SpellEvent")
	end
	saveErrorSpeech = GetCVar("Sound_EnableErrorSpeech")
	SetCVar("Sound_EnableErrorSpeech", 0)
end


function QuietCast:UIErrorsFrame_OnEvent(frame, message, r, g, b)
	if event == "SYSMSG" or event == "UI_INFO_MESSAGE" or event == "UI_ERROR_MESSAGE" then
		for i,text in ipairs(errorList) do
			if text and text == message then				
				return self:DoUnhook()
			end
		end		
	end
	return self.hooks["UIErrorsFrame_OnEvent"](frame, event, message, r, g, b)
end

function QuietCast:DoUnhook()
	self:UnregisterAllEvents()
	self:Unhook("UIErrorsFrame_OnEvent")
	SetCVar("Sound_EnableErrorSpeech", saveErrorSpeech)
end